<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="订单单号" prop="orderCode">
        <el-input

          v-model="queryParams.orderCode"
          placeholder="请输入订单单号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="员工姓名" prop="companyUserNickName">
        <el-input

          v-model="queryParams.companyUserNickName"
          placeholder="请输入员工姓名"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-select  v-model="queryParams.status" placeholder="请选择状态" clearable size="small" >
         <el-option
                v-for="item in statusOptions"
                :key="item.dictValue"
                :label="item.dictLabel"
                :value="item.dictValue"
              />
        </el-select>
      </el-form-item>
      <el-form-item label="售后状态" prop="salesStatus">
        <el-select   v-model="queryParams.salesStatus" placeholder="请选择状态" clearable size="small" >
         <el-option
                v-for="item in salesStatusOptions"
                :key="item.dictValue"
                :label="item.dictLabel"
                :value="item.dictValue"
              />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-table  height="500" border v-loading="loading" :data="storeAfterSalesList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="ID" align="center" prop="id" />
      <el-table-column label="订单单号" align="center" prop="orderCode" />
      <el-table-column label="所属公司" align="center" prop="companyName" />
      <el-table-column label="所属员工" align="center" prop="companyUserNickName" />
      <el-table-column label="会员手机号" align="center" prop="userPhone" />
      <el-table-column label="退款金额" align="center" prop="refundAmount" />
       <el-table-column label="退款类型" align="center" prop="serviceType" >
          <template slot-scope="scope">
              <div prop="serviceType" v-for="(item, index) in serviceTypeOptions"    v-if="scope.row.serviceType==item.dictValue">{{item.dictLabel}}</div>
          </template>
      </el-table-column>
      <el-table-column label="申请原因" align="center" prop="reasons" />
      <el-table-column label="说明" align="center" prop="explains" />
      <el-table-column label="状态" align="center" prop="status" >
          <template slot-scope="scope">
              <div prop="status" v-for="(item, index) in statusOptions"    v-if="scope.row.status==item.dictValue">{{item.dictLabel}}</div>
          </template>
      </el-table-column>
      <el-table-column label="售后状态" align="center" prop="salesStatus" >
          <template slot-scope="scope">
              <div prop="status" v-for="(item, index) in salesStatusOptions"    v-if="scope.row.salesStatus==item.dictValue">{{item.dictLabel}}</div>
          </template>
      </el-table-column>
      <el-table-column label="提交时间" align="center" prop="createTime" />
      <el-table-column label="操作" align="center" fixed="right" width="120px" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            @click="handleShow(scope.row)"
            v-hasPermi="['store:storeAfterSales:query']"
          >查看</el-button>

        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改售后记录对话框 -->
    <el-drawer
     size="75%"
      :title="title" :visible.sync="open"
      >
      <product-after-sales-order  ref="afterSalesOrder" />
    </el-drawer>
  </div>
</template>

<script>
import { myListStoreAfterSales, getStoreAfterSales, delStoreAfterSales, addStoreAfterSales, updateStoreAfterSales, exportStoreAfterSales } from "@/api/hisStore/storeAfterSales";
import productAfterSalesOrder from "../components/productAfterSalesOrder";
export default {
  components: { productAfterSalesOrder },
  name: "StoreAfterSales",
  data() {
    return {
      serviceTypeOptions:[],
      salesStatusOptions:[],
      statusOptions:[],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 售后记录表格数据
      storeAfterSalesList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        orderCode: null,
        refundAmount: null,
        serviceType: null,
        reasons: null,
        explains: null,
        explainImg: null,
        shipperCode: null,
        deliverySn: null,
        deliveryName: null,
        status: null,
        salesStatus: null,
        isDel: null,
        userId: null,
        consignee: null,
        phoneNumber: null,
        address: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getDicts("store_after_sales_sales_status").then((response) => {
        this.salesStatusOptions = response.data;
    });
    this.getDicts("store_after_sales_status").then((response) => {
        this.statusOptions = response.data;
    });
     this.getDicts("store_after_sales_service_type").then((response) => {
        this.serviceTypeOptions = response.data;
    });

    this.getList();
  },
  methods: {
    handleShow(row){
      this.title="售后订单"
      this.open=true;
      setTimeout(() => {
        this.$refs.afterSalesOrder.getStoreAfterSales(row.id);
      }, 200);

    },

    /** 查询售后记录列表 */
    getList() {
      this.loading = true;
      myListStoreAfterSales(this.queryParams).then(response => {
        this.storeAfterSalesList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        orderCode: null,
        refundAmount: null,
        serviceType: null,
        reasons: null,
        explains: null,
        explainImg: null,
        shipperCode: null,
        deliverySn: null,
        deliveryName: null,
        status: 0,
        salesStatus: 0,
        createTime: null,
        isDel: null,
        userId: null,
        consignee: null,
        phoneNumber: null,
        address: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加售后记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getStoreAfterSales(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改售后记录";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateStoreAfterSales(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              }
            });
          } else {
            addStoreAfterSales(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              }
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除售后记录编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delStoreAfterSales(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(function() {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有售后记录数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportStoreAfterSales(queryParams);
        }).then(response => {
          this.download(response.msg);
        }).catch(function() {});
    }
  }
};
</script>
